mod Ex03a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  3. CVICENIE Z PREDMETU 2-INF-121 TEORIA VYPOCITATELNOSTI  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 2.10.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-INF-121-vyp/0708zs/?lang=sk 
  \para* \it  Kontakt:  \end komara1@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym fukciam ('course of values recursion') a Ackermann-Peterovej 
  funkcii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 2 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/2-INF-121-vyp/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 8.10.2007 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end The module \it  Mclsyntax  \end in the file \it  
  mclsyntax.cl  \end contains the syntax of bounded formulas. 

rem 
  \para \bf  [CL] Remark.  \end Catalan pairing function - see the module \it  
  Maux*  \end. For details, see the section \it  3.2 Course of Values Recursion 
   \end in [1]. 

rem 
  \para \bf  [CL] Remark.  \end Do not use the `function' \ft D \end from the 
  module \it  Standard  \end; it plays the role of if-then-else construct. Use 
  rather the function \ft D1(x,y,z) \end defined in the module \it  Maux*  \end 
  with prefix name \it  D1  \end. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Course of values functions.  \end In the following examples use the 
  method of course values sequences to show that the functions in question are 
  primitive recursive. 

rem 
  \para \bf  Exercise.  \end \header* fun Fib 'Tex_f1_n_fib' \end The Fibonacci 
  function \ft Fib(n) \end has the following course of values recursive 
  definition: 

fun Fib 'Tex_f1_n_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

rem 
  \para Show that the function is primitive recursive. 

fun Cvf_fib_debug 'Tex_f1_rec_cvf_f'
  Cvf_fib_debug(0) = 0,0
  Cvf_fib_debug(n+1) = Fib(n+1),Cvf_fib_debug(n)

fun Cvf_fib 'Tex_f1_rec_cvf_f'
  Cvf_fib(n) = Foo

rem 
  \para We require that 
  \eq* 
    L Cvf_fib(n) = n+1
  \end
  \eq* 
    k <= n -> Fib(k) = Sub(Cvf_fib(n),n-k)
  \end

fun Fib_is_primrec 'Tex_f1_n_fib'
  Fib_is_primrec(n) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun Szb 'Tex_f1_nb_sz' \end The binary size function \ft Szb(x) \end 
  has the following course of values recursive definition: 

fun Szb 'Tex_f1_nb_sz'
  Szb(2*x+0) = 0 <- x = 0
  Szb(2*x+0) = Szb(x)+1 <- x != 0
  Szb(2*x+1) = Szb(x)+1

rem 
  \para Show that the function is primitive recursive. 

fun Cvf_szb_debug 'Tex_f1_rec_cvf_f'
  Cvf_szb_debug(0) = 0,0
  Cvf_szb_debug(x+1) = Szb(x+1),Cvf_szb_debug(x)

fun Cvf_szb 'Tex_f1_rec_cvf_f'
  Cvf_szb(x) = Foo

rem 
  \para We require that 
  \eq* 
    L Cvf_szb(x) = x+1
  \end
  \eq* 
    z <= x -> Szb(z) = Sub(Cvf_szb(x),x-z)
  \end

fun Szb_is_primrec 'Tex_f1_nb_sz'
  Szb_is_primrec(x) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end The list concatenation 
  function \ft x++y \end has the following course of values recursive 
  definition: 

fun/2 Conc 'Tex_f2_ln_conc'
  Conc(0,y) = y
  Conc((v,w),y) = v,Conc(w,y)

rem 
  \para Show that the function is primitive recursive. 

fun/2 Cvf_conc_debug 'Tex_f2_rec_cvf_f'
  Cvf_conc_debug(0,y) = y,0
  Cvf_conc_debug(x+1,y) = x+1++y,Cvf_conc_debug(x,y)

fun/2 Cvf_conc 'Tex_f2_rec_cvf_f'
  Cvf_conc(x,y) = Foo

rem 
  \para We require that 
  \eq* 
    L Cvf_conc(x,y) = x+1
  \end
  \eq* 
    z <= x -> Conc(z,y) = Sub(Cvf_conc(x,y),x-z)
  \end

fun/2 Conc_is_primrec 'Tex_f2_ln_conc'
  Conc_is_primrec(x,y) = Foo

rem 
  \para \bf  Course of values recursive definitions.  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  course of values recursive definitions. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

