mod Ex03b

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  3. CVICENIE Z PREDMETU 2-INF-121 TEORIA VYPOCITATELNOSTI  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 2.10.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-INF-121-vyp/0708zs/?lang=sk 
  \para* \it  Kontakt:  \end komara1@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym fukciam ('course of values recursion') a Ackermann-Peterovej 
  funkcii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 1 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/2-INF-121-vyp/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 8.10.2007 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex_f2_rec_ack_mu
  Prefix(100,2,Prefix(50,2,Id(0,Ent('mu'),0),Arg(0)),
         Fenced(Op('[',0),Arg(1),Op(']',0)))

appldisp/3 Tex_f1_rec_ack_ktp
  Std('T',0)

appldisp/2 Tex_f2_rec_ack_cvf
  Prefix(100,2,Underover(Id(1,'A',0),None,Op(Ent('OverBar'),0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_rec_ack_b
  Std('b',0)

rem 
  \para \bf  [CL] Syntax.  \end The module \it  Mclsyntax  \end in the file \it  
  mclsyntax.cl  \end contains the syntax of bounded formulas. 

rem 
  \para \bf  [CL] Syntax.  \end Bounded quantification with membership 
  predicate. Examples: 
  \items 
   \item \para bounded quantifiers \ft \eb y y in x: R \end and 
         \ft \ab y y in x: R \end 
   \item \para \header* pred/2 Q  \end explicit definitions of predicates 
         \def 
           pred R 
           R(x) <-> \eb y y in x: Q(x,y)
         \end
         \def 
           pred R 
           R(x) <-> 
             \ab y y in x: Q(x,y)
         \end
  \end

rem 
  \para \bf  [CL] Remark.  \end Catalan pairing function - see the module \it  
  Maux*  \end. For details, see the section \it  3.2 Course of Values Recursion 
   \end in [1]. 

rem 
  \para \bf  [CL] Remark.  \end Clausal language is allowed. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion.  \end 

rem 
  \para \bf  Subsection. Ackermann-Peter Function.  \end 

rem 
  \para \bf  Ackermann-Peter function.  \end 

fun/2 A 
  A(0,y) = y+1
  A(x+1,0) = A(x,1)
  A(x+1,y+1) = A(x,A(x+1,y))

rem 
  \para \bf  Exercise.  \end Show that the course of values predicate 
  \ft Cvs(s) \end of the Ackermann-Peter function: 
  \eq* 
    Cvs(s) <-> 
    s != 0 & 
    \a a(a in s -> Tuple(3,a) & A(Proj(3,a,1),Proj(3,a,2)) = Proj(3,a,3))
  \end
  \para is primitive recursive. The predicate satisfies the following existence 
  and uniqueness conditions: 
  \eq* 
    \e s(Cvs(s) & \e z x,y,z in s)
  \end
  \eq* 
    Cvs(s1) & x,y,z1 in s1 & Cvs(s2) & x,y,z2 in s2 -> z1 = z2
  \end

pred Cvs 
  Cvs(s) <-> Poo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* pred/3 Ktp 'Tex_f1_rec_ack_ktp' \end Show that there is a unary 
  primitive recursive function \ft U(s) \end and a ternary primitive recursive 
  predicate \ft Ktp(x,y,s) \end such that 
  \eq* 
    A(x,y) = U Tex_f2_rec_ack_mu(s,Tex_f1_rec_ack_ktp(x,y,s))
  \end
  \para The predicate is called the \it  Kleene T-predicate  \end and the 
  property the \it  Kleene normal form  \end of the Ackermann-Peter function. 

fun U 
  U(s) = Foo

pred/3 Ktp 'Tex_f1_rec_ack_ktp'
  Ktp(x,y,s) <-> Poo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Cvf 'Tex_f2_rec_ack_cvf' \end Find a 
  recursive definition of the course of values function \ft Cvf(x,y) \end of 
  \ft A \end. The function is such that the following holds: 
  \eq* 
    Ktp(x,y,Cvf(x,y))
  \end
  \para \it  Hint.  \end Define the function by double nested recursion. 

fun/2 Cvf 'Tex_f2_rec_ack_cvf'
  Cvf(x,y) = Foo

rem 
  \para \bf  Exercise. \it  (bonus 1 point)  \end  \end \header* pred/3 G  \end 
  Show that the graph \ft G(x,y,z) \end of the Ackermann-Peter function 
  \eq* 
    G(x,y,z) <-> A(x,y) = z
  \end
  \para is primitive recursive. 

fun B 'Tex_f1_rec_ack_b'
  B(z) = Foo

pred/3 G 
  G(x,y,z) <-> Poo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para The following queries you may find useful 
  \eq* 
    0,0 = x,y & A(x,y) = z & Cvf(x,y) = s & Cvs(s) & z = U(s) & L(s) = n
  \end
  \eq* 
    0,0 = x,y & A(x,y) = z & Cvf(x,y) = s & Ktp(x,y,s) & z = U(s) & L(s) = n
  \end

